// -------------------------------------------------------------
// KEXtB^
// 
// Copyright (c) 2003 IMAGIRE Takashi. All rights reserved.
// -------------------------------------------------------------

// -------------------------------------------------------------
// O[oϐ
// -------------------------------------------------------------

float MAP_WIDTH;
float MAP_HEIGHT;
float weight[8];

// -------------------------------------------------------------
// eNX`
// -------------------------------------------------------------
texture SrcMap;
sampler SrcSamp = sampler_state
{
    Texture = <SrcMap>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
// -------------------------------------------------------------
// _VF[_sNZVF[_ɓnf[^
// -------------------------------------------------------------
struct VS_OUTPUT
{
    float4 Pos			: POSITION;
	float2 Tex			: TEXCOORD0;
};

// -------------------------------------------------------------
// Xڂ
// -------------------------------------------------------------

// -------------------------------------------------------------
// _VF[_vO
// -------------------------------------------------------------
VS_OUTPUT VS_pass1 (
      float4 Pos    : POSITION,          // f̒_
      float4 Tex    : TEXCOORD0	         // eNX`W
){
    VS_OUTPUT Out = (VS_OUTPUT)0;        // o̓f[^
    
    // ʒuW
    Out.Pos = Pos;
    
    Out.Tex = Tex + float2( 0, 0.5f/MAP_HEIGHT );
    
    return Out;
}

// -------------------------------------------------------------
// sNZVF[_vO
// -------------------------------------------------------------
float4 PS_pass1(VS_OUTPUT In) : COLOR
{   
    float4 Color;
	
	Color  = weight[0] *  tex2D( SrcSamp, In.Tex );
	Color += weight[1]
	 * (tex2D( SrcSamp, In.Tex + float2( + 2.0f/MAP_WIDTH, 0 ) )
	 +  tex2D( SrcSamp, In.Tex + float2( - 2.0f/MAP_WIDTH, 0 ) ));
	Color += weight[2]
	 * (tex2D( SrcSamp, In.Tex + float2( + 4.0f/MAP_WIDTH, 0 ) )
	 +  tex2D( SrcSamp, In.Tex + float2( - 4.0f/MAP_WIDTH, 0 ) ));
	Color += weight[3]
	 * (tex2D( SrcSamp, In.Tex + float2( + 6.0f/MAP_WIDTH, 0 ) )
	 +  tex2D( SrcSamp, In.Tex + float2( - 6.0f/MAP_WIDTH, 0 ) ));
	Color += weight[4]
	 * (tex2D( SrcSamp, In.Tex + float2( + 8.0f/MAP_WIDTH, 0 ) )
	 +  tex2D( SrcSamp, In.Tex + float2( - 8.0f/MAP_WIDTH, 0 ) ));
	Color += weight[5]
	 * (tex2D( SrcSamp, In.Tex + float2( +10.0f/MAP_WIDTH, 0 ) )
	 +  tex2D( SrcSamp, In.Tex + float2( -10.0f/MAP_WIDTH, 0 ) ));
	Color += weight[6]
	 * (tex2D( SrcSamp, In.Tex + float2( +12.0f/MAP_WIDTH, 0 ) )
	 +  tex2D( SrcSamp, In.Tex + float2( -12.0f/MAP_WIDTH, 0 ) ));
	Color += weight[7]
	 * (tex2D( SrcSamp, In.Tex + float2( +14.0f/MAP_WIDTH, 0 ) )
	 +  tex2D( SrcSamp, In.Tex + float2( -14.0f/MAP_WIDTH, 0 ) ));
	
    return Color;
}
// -------------------------------------------------------------
// Yڂ
// -------------------------------------------------------------

// -------------------------------------------------------------
// _VF[_vO
// -------------------------------------------------------------
VS_OUTPUT VS_pass2 (
      float4 Pos    : POSITION,          // f̒_
      float4 Tex    : TEXCOORD0	         // eNX`W
){
    VS_OUTPUT Out = (VS_OUTPUT)0;        // o̓f[^
    
    // ʒuW
    Out.Pos = Pos;
    
    Out.Tex = Tex + float2( 0.5f/MAP_WIDTH, 0 );
    
    return Out;
}

// -------------------------------------------------------------
// sNZVF[_vO
// -------------------------------------------------------------
float4 PS_pass2(VS_OUTPUT In) : COLOR
{   
    float4 Color;
	
	Color  = weight[0] *  tex2D( SrcSamp, In.Tex );
	Color += weight[1]
	 * (tex2D( SrcSamp, In.Tex + float2( 0, + 2.0f/MAP_HEIGHT) )
	 +  tex2D( SrcSamp, In.Tex + float2( 0, - 2.0f/MAP_HEIGHT) ));
	Color += weight[2]
	 * (tex2D( SrcSamp, In.Tex + float2( 0, + 4.0f/MAP_HEIGHT) )
	 +  tex2D( SrcSamp, In.Tex + float2( 0, - 4.0f/MAP_HEIGHT) ));
	Color += weight[3]
	 * (tex2D( SrcSamp, In.Tex + float2( 0, + 6.0f/MAP_HEIGHT) )
	 +  tex2D( SrcSamp, In.Tex + float2( 0, - 6.0f/MAP_HEIGHT) ));
	Color += weight[4]
	 * (tex2D( SrcSamp, In.Tex + float2( 0, + 8.0f/MAP_HEIGHT) )
	 +  tex2D( SrcSamp, In.Tex + float2( 0, - 8.0f/MAP_HEIGHT) ));
	Color += weight[5]
	 * (tex2D( SrcSamp, In.Tex + float2( 0, +10.0f/MAP_HEIGHT) )
	 +  tex2D( SrcSamp, In.Tex + float2( 0, -10.0f/MAP_HEIGHT) ));
	Color += weight[6]
	 * (tex2D( SrcSamp, In.Tex + float2( 0, +12.0f/MAP_HEIGHT) )
	 +  tex2D( SrcSamp, In.Tex + float2( 0, -12.0f/MAP_HEIGHT) ));
	Color += weight[7]
	 * (tex2D( SrcSamp, In.Tex + float2( 0, +14.0f/MAP_HEIGHT) )
	 +  tex2D( SrcSamp, In.Tex + float2( 0, -14.0f/MAP_HEIGHT) ));
	
    return Color;
}

// -------------------------------------------------------------
// eNjbN
// -------------------------------------------------------------
technique TShader
{
    pass P0
    {
        // VF[_
        VertexShader = compile vs_1_1 VS_pass1();
        PixelShader  = compile ps_2_0 PS_pass1();
        
		Sampler[0] = (SrcSamp);
    }
    pass P1
    {
        // VF[_
        VertexShader = compile vs_1_1 VS_pass2();
        PixelShader  = compile ps_2_0 PS_pass2();
        
		Sampler[0] = (SrcSamp);
    }
}
